import '../scss/admin.scss';

/**
 * @param {string} slctr
 * @return {Element|null}
 */
function q(slctr) {
    return document.querySelector(slctr);
}

/**
 * @param {string} slctr
 * @return {NodeListOf<Element>}
 */
function qa(slctr) {
    return document.querySelectorAll(slctr);
}

/**
 * @param {string} id
 * @return {HTMLElement|null}
 */
function id(id) {
    return document.getElementById(id);
}

function performDelete(element, entityType) {
    let confirmDelete = confirm('Do you really want to delete this element?'),
        form = document.createElement('form'),
        idInput = document.createElement('input'),
        csrfInput = document.createElement('input'),
        pfx = entityType.charAt(0),
        tableSelector = `.${entityType}s table`
    ;

    if (confirmDelete === true) {
        csrfInput.setAttribute('type', 'hidden');
        csrfInput.setAttribute('name', `${pfx}-d-csrf`);
        csrfInput.value = element.dataset.csrf;

        idInput.setAttribute('type', 'hidden');
        idInput.setAttribute('name', `${pfx}-d-id`);
        idInput.value = element.dataset.id;

        form.setAttribute('action', q(tableSelector).dataset.deletepath);
        form.setAttribute('method', 'post');

        form.append(idInput);
        form.append(csrfInput);
        form.submit();
    }
}

qa('.topics td a[data-target="delete"]').forEach(function (element) {
    element.addEventListener('click', function () {
        performDelete(element, 'topic');
    });
});